#define USE_ARDUINO_INTERRUPTS true
#include <PulseSensorPlayground.h>
#include <TFT.h>

#define cs   10
#define dc   9
#define rst  8

#define cs   10
#define dc   9
#define rst  8

TFT TFTscreen = TFT(cs, dc, rst);

//const int OUTPUT_TYPE = SERIAL_PLOTTER;
const int PULSE_SENSOR_COUNT = 2;

const int PULSE_INPUT0 = A0;
const int PULSE_INPUT1 = A1;
//const int PULSE_INPUT2 = A2;
//const int PULSE_INPUT3 = A3;
const int THRESHOLD = 550;
int average = 100;

PulseSensorPlayground pulseSensor(PULSE_SENSOR_COUNT);
int speaker = 0;
byte sampleAmount = 5; //max=255; Current amount of samples taken
int sampleHeart;//sample numbers; standard higer bound of a person is 100
int sampleBreath;//sample numbers; standard higer bound a person is 19
int sampleCounter;//To count the amount of current samples taken
float Endvalue;
//Serial Communication protocol
char headers[] = {'A', 'B', 'C', 'X', 'Y', 'Z'};
void setup() {
  Serial.begin(9600);
  Serial.println("Start");

  TFTscreen.begin();
  TFTscreen.background(0, 0, 0); //Start with a black screen
  pulseSensor.analogInput(PULSE_INPUT0, 0);
  pulseSensor.analogInput(PULSE_INPUT1, 1);
  //pulseSensor.analogInput(PULSE_INPUT2, 2);
  //pulseSensor.analogInput(PULSE_INPUT3, 3);
  pulseSensor.setThreshold(THRESHOLD);
  if (pulseSensor.begin()) {
  }
}

void loop() {
//  if (sampleCounter < sampleAmount) {
//    sampleHeart += 100; //sample value to give the higherbound
//    sampleBreath += 19; //sample value to give the higherbound
//    sampleCounter++;//Count the amount of samples given
//    delay(1000);
//  } else if (sampleCounter == sampleAmount) {
//    sampleHeart = sampleHeart / sampleAmount;
//    sampleBreath = sampleBreath / sampleAmount;
//    sampleCounter++;
//  } else {
    delay(1000);
    //calculate(16.0, 19.0, 16.0) +
    
    // put your main code here, to run repeatedly:
    if (!Endvalue < 20) {
      TFTscreen.background(20, 20, 20);
//      for (int j = 0; j < 1; j++) { //Donker Grijs
//        tone(speaker, 500);
//        delay(50);
//        noTone(speaker);
//        delay(50);
//      }
    }
    if (Endvalue >= 20 && Endvalue < 40) {
      TFTscreen.background(0, 255, 0); //Groen
//      for (int j = 0; j < 1; j++) {
//        tone(speaker, 500);
//        delay(50);
//        noTone(speaker);
//        delay(50);
//      }
    }
    if (Endvalue >= 40 && Endvalue < 60) {
      TFTscreen.background(0, 255, 255); //Geel
      for (int j = 0; j < 2; j++) {
        tone(speaker, 1000);
        delay(50);
        noTone(speaker);
        delay(50);
      }
    }
    if (Endvalue >= 60 && Endvalue < 80) {
      TFTscreen.background(0, 185, 255); //Oranje
      for (int j = 0; j < 3; j++) {
        tone(speaker, 1500);
        delay(50);
        noTone(speaker);
        delay(50);
      }
    }
    if (Endvalue >= 80 && Endvalue < 100) {
      TFTscreen.background(0, 0, 255); //Rood
      for (int j = 0; j < 4; j++) {
        tone(speaker, 2000);
        delay(10);
        noTone(speaker);
        delay(10);
      }
    }
    if (Endvalue >= 100) {
      TFTscreen.background(0, 0, 255); //Knipperend Wit Rood
      boolean color = false;
      for (int j = 0; j < 5; j++) {
        tone(speaker, 2000);
        delay(50);
        noTone(speaker);
        if (color) {
          TFTscreen.background(255, 255, 255);
          color = false;
        } else {
          TFTscreen.background(0, 0, 255);
          color = true;
        }
      }
    }
    int myBPM1 = pulseSensor.getBeatsPerMinute(0);
    int myBPM2 = pulseSensor.getBeatsPerMinute(1);

    //int myBPM3 = pulseSensor.getBeatsPerMinute(2);
    //int myBPM4 = pulseSensor.getBeatsPerMinute(3);
    average = (myBPM1 + myBPM2) / PULSE_SENSOR_COUNT;
    Endvalue = (calculate(average, 100, 60)); //Calculate the sleepiness
    if (pulseSensor.sawStartOfBeat()) {
//      Serial.print("myBPM(A0): ");
//      Serial.print(myBPM1);
//      Serial.print("  myBPM(A1): ");
//      Serial.print(myBPM2);
      /*Serial.print("  myBPM(A2): ");
        Serial.print(myBPM3);
        Serial.print("  myBPM(A3): ");
        Serial.print(myBPM4); */
//      Serial.print("  Average: ");
//      Serial.println(average);
    }
  //}
  float pins[] = {float(average), Endvalue}; //heartrate, breathing rate, calc heartrate, calc breathrate, sleepiness
  Serial.print(headers[0]);
  Serial.print(average);
  Serial.print(headers[1]);
  Serial.println(Endvalue);

}
float calculate(float x1, float sampleVal, float lowerBound) {
  float value = (100.0 * (pow(0.1, (x1 / (sampleVal - lowerBound))))) / (pow(0.1, lowerBound / (sampleVal - lowerBound)));
  return value;
}
